## superlu-dist 9.2.0+dfsg1

=== CMakeLists.txt ===
######################################################################
#
# CMakeLists.txt for SUPERLU_DIST
#
######################################################################

# Required version
cmake_minimum_required(VERSION 3.18.1 FATAL_ERROR)

# Project version numbers
#project(SuperLU_DIST C CXX CUDA)
project(SuperLU_DIST C CXX)
set(VERSION_MAJOR "9")
set(VERSION_MINOR "2")
set(VERSION_BugFix "0")
set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Set up options
option(enable_doc       "Build doxygen documentation" OFF)
option(enable_single    "Enable single precision library" ON)
option(enable_double    "Enable double precision library" ON)
option(enable_complex16 "Enable complex16 precision library" ON)
option(enable_tests  "Build tests" ON)
option(enable_examples  "Build examples" ON)
option(XSDK_ENABLE_Fortran "Enable Fortran" ON)
option(enable_python "Enable Python" ON)

#-- BLAS
option(TPL_ENABLE_INTERNAL_BLASLIB  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
option(TPL_BLAS_LIBRARIES "List of absolute paths to blas libraries [].")
#-- ParMETIS
option(TPL_ENABLE_PARMETISLIB   "Enable the ParMETIS library" ON)
option(TPL_PARMETIS_LIBRARIES "List of absolute paths to ParMETIS link libraries [].")
option(TPL_PARMETIS_INCLUDE_DIRS "List of absolute paths to ParMETIS include directories [].")
#-- COLAMD
option(TPL_ENABLE_COLAMDLIB   "Enable the COLAMD library" OFF)
option(TPL_COLAMD_LIBRARIES "List of absolute paths to COLAMD link libraries [].")
option(TPL_COLAMD_INCLUDE_DIRS "List of absolute paths to COLAMD include directories [].")
#-- LAPACK
option(TPL_ENABLE_LAPACKLIB "Enable LAPACK library" OFF)
option(TPL_LAPACK_LIBRARIES "List of absolute paths to LAPACK libraries [].")
#-- CombBLAS
option(TPL_ENABLE_COMBBLASLIB   "Build the CombBLAS library" OFF)
option(TPL_COMBBLAS_LIBRARIES "List of absolute paths to CombBLAS link libraries [].")
option(TPL_COMBBLAS_INCLUDE_DIRS "List of absolute paths to CombBLAS include directories [].")
#-- CUDA
option(TPL_ENABLE_CUDALIB   "Enable the CUDA libraries" OFF)
option(TPL_ENABLE_HIPLIB   "Enable the HIP libraries" OFF)
#-- NVSHMEM
option(TPL_ENABLE_NVSHMEM   "Enable the NVSHMEM libraries" OFF)
option(TPL_ENABLE_ROCSHMEM   "Enable the ROCSHMEM libraries" OFF)
#-- MAGMA 
option(TPL_ENABLE_MAGMALIB "Enable the MAGMA library" OFF)

######################################################################
#
# IDEAS: xSDK standards module
#MESSAGE("\nProcess XSDK defaults ...")
# SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
#INCLUDE("cmake/XSDKDefaults.cmake")
######################################################################

include(CTest)
include(CheckLanguage)

######################################################################
#
# Usual initialization stuff
#
######################################################################
if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
  #set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#message("!!!! top: cxx_implicit='${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}'")

if (XSDK_ENABLE_Fortran)
  enable_language (Fortran)
  set(NOFORTRAN FALSE)
endif()

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")

#---- For shared library

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
#----

SET(BUILD_STATIC_LIBS TRUE CACHE BOOL "Include static libs when building shared")

if (BUILD_SHARED_LIBS)
  message("-- SuperLU_DIST will be built as a shared library.")
  # set the position independent code property on all targets, so that
  # -fPIC is added in compiler flag.
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)

  set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.so)
  SET(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath,${CMAKE_INSTALL_PREFIX}/SRC")

  if (BUILD_STATIC_LIBS)
    message("-- SuperLU_DIST will also be built as a static library.")
  endif()
  set(SHARED_C_FLAGS_EXPORT ${CMAKE_SHARED_LIBRARY_C_FLAGS})
else()
  message("-- SuperLU_DIST will be built as a static library.")
  set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.a)
endif()

set(SUPERLU_VERSION "${PROJECT_VERSION}")
set(SUPERLU_REV "${PROJECT_REV}")

# The XSDK standard does not allow using internally built BLAS
if (USE_XSDK_DEFAULTS)
  set(enable_blaslib_DEFAULT OFF)
else()
  set(enable_blaslib_DEFAULT ON)
endif()

if (NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX /usr/local)
endif()

if(NOT MSVC)
  include(GNUInstallDirs)
  set(default_install_inc_dir ${CMAKE_INSTALL_INCLUDEDIR})
  set(default_install_lib_dir ${CMAKE_INSTALL_LIBDIR})
  set(default_install_bin_dir ${CMAKE_INSTALL_BINDIR})
else() # for Windows
  set(default_install_inc_dir "include")
  set(default_install_lib_dir "lib")
  set(default_install_bin_dir "bin")
endif()

set(INSTALL_INC_DIR "${default_install_inc_dir}" CACHE STRING "The folder where headers will be installed.")
set(INSTALL_LIB_DIR "${default_install_lib_dir}" CACHE STRING "The folder where libraries will be installed.")
set(INSTALL_BIN_DIR "${default_install_bin_dir}" CACHE STRING "The folder where runtime files will be installed.")

# Set up required compiler defines and options.
## get_directory_property( DirDefs COMPILE_DEFINITIONS )

if(XSDK_INDEX_SIZE EQUAL 64)
    message("-- Using 64 bit integer for index size.")
endif()	
set(CMAKE_C_FLAGS_RELEASE "-O3 -g" CACHE STRING "")
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g" CACHE STRING "")
set(CMAKE_Fortran_FLAGS_RELEASE "-O3 -g" CACHE STRING "")

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -O0")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0")

######################################################################
#
# Find packages
#
######################################################################
#
#--------------------- MPI ---------------------
#find_package(MPI REQUIRED)
find_package(MPI)
if(MPI_C_FOUND)
    set(CMAKE_C_FLAGS "${MPI_C_COMPILE_FLAGS} ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${MPI_CXX_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${MPI_C_LINK_FLAGS}" )
#    message("MPI_C_INCLUDE_DIRS: ${MPI_C_INCLUDE_DIRS}")
endif()
if (XSDK_ENABLE_Fortran)
  if(MPI_Fortran_FOUND)
    set(CMAKE_Fortran_FLAGS "${MPI_Fortran_COMPILE_FLAGS} ${CMAKE_Fortran_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${MPI_Fortran_LINK_FLAGS}")
    include_directories(${MPI_Fortran_INCLUDE_PATH})
  endif()
endif()  

#---- CUDA libraries
if (TPL_ENABLE_CUDALIB)   ## want to use cuda
  check_language(CUDA)
  if(CMAKE_CUDA_COMPILER)
    message("-- Enabled support for CUDA.")
    enable_language(CUDA)
    find_package(CUDA REQUIRED)
    if (CUDA_FOUND)
      set(CUDA_SEPARABLE_COMPILATION ON)  
      if(NOT CMAKE_CUDA_ARCHITECTURES)
        # if(${CMAKE_VERSION} VERSION_LESS_EQUAL "3.13.4")
        #   cuda_select_nvcc_arch_flags(ARCH_FLAGS "Auto") # optional argument for arch to add
        #   message("ARCH_FLAGS = ${ARCH_FLAGS}")
        #   string(REPLACE "-gencode;" "--generate-code=" ARCH_FLAGS "${ARCH_FLAGS}")
        #   string(APPEND CMAKE_CUDA_FLAGS "${ARCH_FLAGS}")
        # else()
        include(FindCUDA/select_compute_arch)
        CUDA_DETECT_INSTALLED_GPUS(INSTALLED_GPU_CCS_1)
        string(STRIP "${INSTALLED_GPU_CCS_1}" INSTALLED_GPU_CCS_2)
        string(REPLACE " " ";" INSTALLED_GPU_CCS_3 "${INSTALLED_GPU_CCS_2}")
        string(REPLACE "." "" CUDA_ARCH_LIST "${INSTALLED_GPU_CCS_3}")
        SET(CMAKE_CUDA_ARCHITECTURES ${CUDA_ARCH_LIST})
        set_property(GLOBAL PROPERTY CUDA_ARCHITECTURES "${CUDA_ARCH_LIST}")
      # endif()
      endif()
      set(HAVE_CUDA TRUE)
      if (TPL_ENABLE_NVSHMEM)
        set(CMAKE_CUDA_FLAGS_RELEASE "-O3 --expt-relaxed-constexpr -DNDEBUG -rdc=true" CACHE STRING "")
      else()
        set(CMAKE_CUDA_FLAGS_RELEASE "-O3 --expt-relaxed-constexpr -DNDEBUG" CACHE STRING "")
      endif()
      set(CMAKE_CUDA_FLAGS_DDEBUG "-O0 --expt-relaxed-constexpr -DDEBUG -g" CACHE STRING "")
    endif()

#     find_package(CUB REQUIRED)

    find_package(CUDAToolkit REQUIRED)
# The following appears SRC/CMakeLists.txt
#    if(CUDAToolkit_FOUND)
#      target_link_libraries(superlu_dist PUBLIC CUDA::cudart CUDA::cusolver CUDA::cublas)
#    endif()
    message("-- CUDAToolkit_LIBRARY_ROOT='${CUDAToolkit_LIBRARY_ROOT}'")
    if (NOT "${CUDAToolkit_LIBRARY_ROOT}" STREQUAL "")
       set(CUDA_LIBRARIES "${CUDAToolkit_LIBRARY_ROOT}/lib64/libcudart.so")
       # expose the following to make.inc, but location may not be reliable
       # set(CUDA_CUBLAS_LIBRARIES "${CUDAToolkit_LIBRARY_ROOT}/lib64/libcublas.so")
       set(CUDA_CUSPARSE_LIBRARIES "${CUDAToolkit_LIBRARY_ROOT}/lib64/libcusparse.so")
       set(CUDA_CUSOLVER_LIBRARIES "${CUDAToolkit_LIBRARY_ROOT}/lib64/libcusolver.so")
    else()
	message("-- CUDAToolkit_LIBRARY_ROOT empty, not setting CUDA_LIBRARIES")
    endif()

#     # The following make.inc exporting does not work
#     set(CUDA_LIB CUDA::cudart CUDA::cublas CUDA::cusolver)
# # fix up CUDA library names    
#     string (REPLACE ";" " " CUDA_LIB_STR "${CUDA_LIB}")
#     set(CUDA_LIB_EXPORT ${CUDA_LIB_STR}) 
#     set(HAVE_CUDA TRUE)
    # set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_CUDA")
    # set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -DHAVE_CUDA")
  else()
    message("-- CUDA libraries not found.")
  endif()
endif()


#--------------------- OpenMP ---------------------
if (NOT DEFINED enable_openmp)
  set(enable_openmp TRUE)
endif ()
if (enable_openmp)
  find_package(OpenMP)
## include(FindOpenMP)  # Strumpack uses this

  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
# The following causes problem with cmake/3.20.+
# set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
    message("-- OpenMP_EXE_LINKER_FLAGS='${OpenMP_EXE_LINKER_FLAGS}'")
    message("-- CMAKE_EXE_LINKER_FLAGS='${CMAKE_EXE_LINKER_FLAGS}'")
  endif()  
endif()


include(CheckLanguage)

#--------------------- CUDA libraries ---------------------
if (TPL_ENABLE_CUDALIB)   ## want to use cuda
  check_language(CUDA)
  if(CMAKE_CUDA_COMPILER)
    message("-- Enabled support for CUDA.")
    enable_language(CUDA)
    find_package(CUDAToolkit REQUIRED)

    # make.inc exporting not yet tested
    set(CUDA_LIB CUDA::cudart CUDA::cublas CUDA::cusolver)
    string (REPLACE ";" " " CUDA_LIB_STR "${CUDA_LIB}")
    set(CUDA_LIB_EXPORT ${CUDA_LIB_STR}) 
    set(HAVE_CUDA TRUE)
    # set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_CUDA")
    # set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -DHAVE_CUDA")

    #--------------------- NVSHMEM libraries ---------------------
    if (TPL_ENABLE_NVSHMEM)   ## want to use nvshmem
        set(NVSHMEM_LIB ${TPL_NVSHMEM_LIBRARIES}) 
        message("-- Enabled support for NVSHMEM='${NVSHMEM_LIB}'")
        set(HAVE_NVSHMEM TRUE)
    endif()

  else()
    message("-- CUDA libraries not found.")
  endif()
endif()




#--------------------- HIP libraries ---------------------
if (TPL_ENABLE_HIPLIB)   ## want to use hip
  find_package(HIP MODULE)
  if(HIP_FOUND)
    message("-- Enabled support for HIP.")
    find_package(hipblas REQUIRED)
    find_package(rocsolver REQUIRED)
    find_package(rocblas REQUIRED)
    set(HIP_LIB roc::hipblas roc::rocblas roc::rocsolver)
    message("HIP_LIB ${HIP_LIB}")

=== CBLAS/CMakeLists.txt ===
set(headers 
    f2c.h
)
set(sources input_error_dist.c)

if (enable_single)
    list(APPEND sources
      isamax.c
      sasum.c
      saxpy.c
      scopy.c
      sdot.c
      snrm2.c
      srot.c
      sscal.c
      sgemv.c
      ssymv.c
      strsv.c
      sger.c
      ssyr2.c
      sgemm.c
      strsm.c
    )
endif()

if (enable_double)
    list(APPEND sources
      idamax.c
      dasum.c
      daxpy.c
      dcopy.c
      ddot.c
      dnrm2.c
      drot.c
      dscal.c
      dgemv.c
      dsymv.c
      dtrsv.c
      dger.c
      dsyr2.c
      dgemm.c
      dtrsm.c
    )
endif()

if (enable_complex16)
    list(APPEND sources
      izamax.c
      dzasum.c
      zaxpy.c
      zcopy.c
      dznrm2.c
      zscal.c
      dcabs1.c
      z_internal.c
      zgemv.c
      zhemv.c
      ztrsv.c
      zgerc.c
      zgeru.c
      zher2.c
      zgemm.c
      ztrsm.c
    )
endif()

add_library(blas ${sources} ${HEADERS})

install(TARGETS blas DESTINATION "${INSTALL_LIB_DIR}")
install(FILES ${headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== DOC/requirements.txt ===
sphinxcontrib-bibtex==2.6.2
sphinxcontrib-katex==0.9.10
sphinxcontrib-svg2pdfconverter==1.2.2
sphinx-copybutton==0.5.2
sphinx-design==0.6.0
myst-parser==4.0.0
sphinx-remove-toctrees==1.0.0.post1
Jinja2==3.1.3
# docutils 0.19.1 produces bad HTML from the references in PCFIELDSPLIT
numpy==2.0.0
wheel==0.43.0
pydata-sphinx-theme==0.15.1
sphinx==7.3.7
sphobjinv==2.3.1.1
typing_extensions==4.12.2
pylit==0.8.0
setuptools==70.2.0
sphinx-design

=== EXAMPLE/CMakeLists.txt ===
include_directories(${SuperLU_DIST_SOURCE_DIR}/SRC)

# Libs linked to all of the examples
#set(all_link_libs superlu_dist ${BLAS_LIB} ${NVSHMEM_LIB})
set(all_link_libs superlu_dist ${BLAS_LIB})
if (NOT MSVC)
  list(APPEND all_link_libs m)
endif ()

function(add_superlu_dist_example target input nprow npcol)
    set(EXAMPLE_INPUT "${SuperLU_DIST_SOURCE_DIR}/EXAMPLE/${input}")
    set(EXAMPLE_OUTPUT "${SuperLU_DIST_BINARY_DIR}/EXAMPLE/${target}.out")

##  get_target_property(TEST_LOC ${target} LOCATION)
    set(EXAMPLE_LOC ${CMAKE_CURRENT_BINARY_DIR})

    MATH( EXPR procs "${nprow}*${npcol}" )
#    message("MPIEXEC_FLAG is ${MPIEXEC_NUMPROC_FLAG}")

# corresponding to mpiexec -n 4 pddrive -r <nprow> -c <npcol> g20.rua
    add_test(${target} ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${procs}
             ${MPIEXEC_PREFLAGS} ${EXAMPLE_LOC}/${target} ${MPIEXEC_POSTFLAGS} -r "${nprow}" -c "${npcol}" "${EXAMPLE_INPUT}")

#     add_test(NAME ${target} COMMAND "${CMAKE_COMMAND}"
#              -DTEST=${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${procs}
#             ${MPIEXEC_PREFLAGS} ${target} ${MPIEXEC_POSTFLAGS} -r "${nprow}" -c "${npcol}" "${TEST_INPUT}"
#	     -DOUTPUT=${target}.out
#	    -P "${SuperLU_DIST_SOURCE_DIR}/EXAMPLE/runexample.cmake" )

# MPI variables:
# ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} PROCS
#  	${MPIEXEC_PREFLAGS} EXECUTABLE ${MPIEXEC_POSTFLAGS} ARGS)

endfunction(add_superlu_dist_example)


if(enable_double)
  set(DEXM pddrive.c dcreate_matrix.c)
  add_executable(pddrive ${DEXM})
  target_link_libraries(pddrive ${all_link_libs})
  install(TARGETS pddrive RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM1 pddrive1.c dcreate_matrix.c)
  add_executable(pddrive1 ${DEXM1})
  target_link_libraries(pddrive1 ${all_link_libs})
  add_superlu_dist_example(pddrive1 big.rua 2 2)
  install(TARGETS pddrive1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM2 pddrive2.c dcreate_matrix.c dcreate_matrix_perturbed.c)
  add_executable(pddrive2 ${DEXM2})
  target_link_libraries(pddrive2 ${all_link_libs})
  add_superlu_dist_example(pddrive2 big.rua 2 2)
  install(TARGETS pddrive2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM3 pddrive3.c dcreate_matrix.c)
  add_executable(pddrive3 ${DEXM3})
  target_link_libraries(pddrive3 ${all_link_libs})
  add_superlu_dist_example(pddrive3 big.rua 2 2)
  install(TARGETS pddrive3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM4 pddrive4.c dcreate_matrix.c)
  add_executable(pddrive4 ${DEXM4})
  target_link_libraries(pddrive4 ${all_link_libs})
  install(TARGETS pddrive4 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  

  set(DEXM3D pddrive3d.c dcreate_matrix.c dcreate_matrix3d.c)
  add_executable(pddrive3d ${DEXM3D})
  target_link_libraries(pddrive3d ${all_link_libs})
  install(TARGETS pddrive3d RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  

  set(DEXM3D pddrive3d_block_diag.c dcreate_matrix.c dcreate_matrix3d.c)
  add_executable(pddrive3d_block_diag ${DEXM3D})
  target_link_libraries(pddrive3d_block_diag ${all_link_libs})
  install(TARGETS pddrive3d_block_diag RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")
  
  set(DEXM3D1 pddrive3d1.c dcreate_matrix.c dcreate_matrix3d.c)
  add_executable(pddrive3d1 ${DEXM3D1})
  target_link_libraries(pddrive3d1 ${all_link_libs})
  install(TARGETS pddrive3d1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM3D2 pddrive3d2.c dcreate_matrix.c dcreate_matrix3d.c)
  add_executable(pddrive3d2 ${DEXM3D2})
  target_link_libraries(pddrive3d2 ${all_link_libs})
  install(TARGETS pddrive3d2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXM3D3 pddrive3d3.c dcreate_matrix.c dcreate_matrix3d.c)
  add_executable(pddrive3d3 ${DEXM3D3})
  target_link_libraries(pddrive3d3 ${all_link_libs})
  install(TARGETS pddrive3d3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMG pddrive_ABglobal.c)
  add_executable(pddrive_ABglobal ${DEXMG})
  target_link_libraries(pddrive_ABglobal ${all_link_libs})
  install(TARGETS pddrive_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMG1 pddrive1_ABglobal.c)
  add_executable(pddrive1_ABglobal ${DEXMG1})
  target_link_libraries(pddrive1_ABglobal ${all_link_libs})
  install(TARGETS pddrive1_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMG2 pddrive2_ABglobal.c)
  add_executable(pddrive2_ABglobal ${DEXMG2})
  target_link_libraries(pddrive2_ABglobal ${all_link_libs})
  install(TARGETS pddrive2_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMG3 pddrive3_ABglobal.c)
  add_executable(pddrive3_ABglobal ${DEXMG3})
  target_link_libraries(pddrive3_ABglobal ${all_link_libs})
  install(TARGETS pddrive3_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMG4 pddrive4_ABglobal.c)
  add_executable(pddrive4_ABglobal ${DEXMG4})
  target_link_libraries(pddrive4_ABglobal ${all_link_libs})
  install(TARGETS pddrive4_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(DEXMS pddrive_spawn.c dcreate_matrix.c)
  add_executable(pddrive_spawn ${DEXMS})
  target_link_libraries(pddrive_spawn ${all_link_libs})
  install(TARGETS pddrive_spawn RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  

endif() #### end enable_double

if(enable_single)
  set(SEXM psdrive.c screate_matrix.c screate_A_x_b.c)
  add_executable(psdrive ${SEXM})
  target_link_libraries(psdrive ${all_link_libs})
  install(TARGETS psdrive RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM1 psdrive1.c screate_matrix.c)
  add_executable(psdrive1 ${SEXM1})
  target_link_libraries(psdrive1 ${all_link_libs})
  add_superlu_dist_example(psdrive1 big.rua 2 2)
  install(TARGETS psdrive1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM2 psdrive2.c screate_matrix.c screate_matrix_perturbed.c)
  add_executable(psdrive2 ${SEXM2})
  target_link_libraries(psdrive2 ${all_link_libs})
  add_superlu_dist_example(psdrive2 big.rua 2 2)
  install(TARGETS psdrive2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM3 psdrive3.c screate_matrix.c)
  add_executable(psdrive3 ${SEXM3})
  target_link_libraries(psdrive3 ${all_link_libs})
  add_superlu_dist_example(psdrive3 big.rua 2 2)
  install(TARGETS psdrive3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM4 psdrive4.c screate_matrix.c)
  add_executable(psdrive4 ${SEXM4})
  target_link_libraries(psdrive4 ${all_link_libs})
  install(TARGETS psdrive4 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM3D psdrive3d.c screate_matrix.c screate_matrix3d.c)
  add_executable(psdrive3d ${SEXM3D})
  target_link_libraries(psdrive3d ${all_link_libs})
  install(TARGETS psdrive3d RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM3D1 psdrive3d1.c screate_matrix.c screate_matrix3d.c)
  add_executable(psdrive3d1 ${SEXM3D1})
  target_link_libraries(psdrive3d1 ${all_link_libs})
  install(TARGETS psdrive3d1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM3D2 psdrive3d2.c screate_matrix.c screate_matrix3d.c)
  add_executable(psdrive3d2 ${SEXM3D2})
  target_link_libraries(psdrive3d2 ${all_link_libs})
  install(TARGETS psdrive3d2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(SEXM3D3 psdrive3d3.c screate_matrix.c screate_matrix3d.c)
  add_executable(psdrive3d3 ${SEXM3D3})
  target_link_libraries(psdrive3d3 ${all_link_libs})
  install(TARGETS psdrive3d3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  

endif() #### end enable_single


if(enable_complex16)

  set(ZEXM pzdrive.c zcreate_matrix.c)
  add_executable(pzdrive ${ZEXM})
  target_link_libraries(pzdrive ${all_link_libs})
  install(TARGETS pzdrive RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM1 pzdrive1.c zcreate_matrix.c)
  add_executable(pzdrive1 ${ZEXM1})
  target_link_libraries(pzdrive1 ${all_link_libs})
  add_superlu_dist_example(pzdrive1 cg20.cua 2 2)
  install(TARGETS pzdrive1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM2 pzdrive2.c zcreate_matrix.c zcreate_matrix_perturbed.c)
  add_executable(pzdrive2 ${ZEXM2})
  target_link_libraries(pzdrive2 ${all_link_libs})
  add_superlu_dist_example(pzdrive2 cg20.cua 2 2)
  install(TARGETS pzdrive2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM3 pzdrive3.c zcreate_matrix.c)
  add_executable(pzdrive3 ${ZEXM3})
  target_link_libraries(pzdrive3 ${all_link_libs})
  add_superlu_dist_example(pzdrive3 cg20.cua 2 2)
  install(TARGETS pzdrive3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  

  set(ZEXM4 pzdrive4.c zcreate_matrix.c)
  add_executable(pzdrive4 ${ZEXM4})
  target_link_libraries(pzdrive4 ${all_link_libs})
  install(TARGETS pzdrive4 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM3D pzdrive3d.c zcreate_matrix.c zcreate_matrix3d.c)
  add_executable(pzdrive3d ${ZEXM3D})
  target_link_libraries(pzdrive3d ${all_link_libs})
  install(TARGETS pzdrive3d RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  
  set(ZEXM3DQCD pzdrive3d_qcd.cpp )
  add_executable(pzdrive3d_qcd ${ZEXM3DQCD})
  target_link_libraries(pzdrive3d_qcd ${all_link_libs})
  install(TARGETS pzdrive3d_qcd RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE") 


  set(ZEXM3D1 pzdrive3d1.c zcreate_matrix.c zcreate_matrix3d.c)
  add_executable(pzdrive3d1 ${ZEXM3D1})
  target_link_libraries(pzdrive3d1 ${all_link_libs})
  install(TARGETS pzdrive3d1 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM3D2 pzdrive3d2.c zcreate_matrix.c zcreate_matrix3d.c)
  add_executable(pzdrive3d2 ${ZEXM3D2})
  target_link_libraries(pzdrive3d2 ${all_link_libs})
  install(TARGETS pzdrive3d2 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXM3D3 pzdrive3d3.c zcreate_matrix.c zcreate_matrix3d.c)
  add_executable(pzdrive3d3 ${ZEXM3D3})
  target_link_libraries(pzdrive3d3 ${all_link_libs})
  install(TARGETS pzdrive3d3 RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXMG pzdrive_ABglobal.c)
  add_executable(pzdrive_ABglobal ${ZEXMG})
  target_link_libraries(pzdrive_ABglobal ${all_link_libs})
  install(TARGETS pzdrive_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXMG1 pzdrive1_ABglobal.c)
  add_executable(pzdrive1_ABglobal ${ZEXMG1})
  target_link_libraries(pzdrive1_ABglobal ${all_link_libs})
  install(TARGETS pzdrive1_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")  
  
  set(ZEXMG2 pzdrive2_ABglobal.c)
  add_executable(pzdrive2_ABglobal ${ZEXMG2})
  target_link_libraries(pzdrive2_ABglobal ${all_link_libs})
  install(TARGETS pzdrive2_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")   
  
  set(ZEXMG3 pzdrive3_ABglobal.c)
  add_executable(pzdrive3_ABglobal ${ZEXMG3})
  target_link_libraries(pzdrive3_ABglobal ${all_link_libs})
  install(TARGETS pzdrive3_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")   
  
  set(ZEXMG4 pzdrive4_ABglobal.c)
  add_executable(pzdrive4_ABglobal ${ZEXMG4})
  target_link_libraries(pzdrive4_ABglobal ${all_link_libs})
  install(TARGETS pzdrive4_ABglobal RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")   
  
  set(ZEXMS pzdrive_spawn.c zcreate_matrix.c)
  add_executable(pzdrive_spawn ${ZEXMS})
  target_link_libraries(pzdrive_spawn ${all_link_libs})  
  install(TARGETS pzdrive_spawn RUNTIME DESTINATION "${INSTALL_LIB_DIR}/EXAMPLE")   

endif()

=== FORTRAN/CMakeLists.txt ===
# include the paths for header files
include_directories(${SuperLU_DIST_SOURCE_DIR}/SRC)
include_directories(${SuperLU_DIST_BINARY_DIR}/FORTRAN)

set(sources
    superlu_c2f_wrap.c  # initialize precision-independent file
    superlupara.f90
    superlu_mod.f90
    )

if(enable_double)
  list(APPEND sources c2f_dcreate_matrix_x_b.c superlu_c2f_dwrap.c)
endif()
if(enable_complex16)
  list(APPEND sources c2f_zcreate_matrix_x_b.c superlu_c2f_zwrap.c)
endif()  

add_library(superlu_dist_fortran ${sources})
if(BUILD_STATIC_LIBS)
  add_library(superlu_dist_fortran-static STATIC ${sources})
endif()
# set(targets superlu_dist_fortran)
get_target_property(superlu_dist_version superlu_dist VERSION)
get_target_property(superlu_dist_soversion superlu_dist SOVERSION)
set_target_properties(superlu_dist_fortran PROPERTIES VERSION ${superlu_dist_version})
set_target_properties(superlu_dist_fortran PROPERTIES SOVERSION ${superlu_dist_soversion})
target_link_libraries(superlu_dist_fortran superlu_dist)

if (BUILD_STATIC_LIBS)
  set_target_properties(superlu_dist_fortran-static PROPERTIES OUTPUT_NAME superlu_dist_fortran)
  set_target_properties(superlu_dist_fortran-static PROPERTIES VERSION ${superlu_dist_version})
  set_target_properties(superlu_dist_fortran-static PROPERTIES SOVERSION ${superlu_dist_soversion})
  target_link_libraries(superlu_dist_fortran-static superlu_dist)
endif()

# depends on FPP defs
add_dependencies(superlu_dist_fortran config_f)
if(BUILD_STATIC_LIBS)
  add_dependencies(superlu_dist_fortran-static config_f)
  add_dependencies(superlu_dist_fortran-static superlu_dist_fortran)
endif()

install(TARGETS superlu_dist_fortran
# DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
    ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
)
if (BUILD_STATIC_LIBS)
  install(TARGETS superlu_dist_fortran-static
  # DESTINATION ${CMAKE_INSTALL_LIBDIR}
      RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
      LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
      ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
  )
endif()

install(FILES superlu_dist_config.fh 
  ${CMAKE_CURRENT_BINARY_DIR}/superlu_mod.mod 
  ${CMAKE_CURRENT_BINARY_DIR}/superlupara_mod.mod
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

# Fortran MPI stuff
add_definitions(${MPI_Fortran_COMPILE_FLAGS})
include_directories(${MPI_Fortran_INCLUDE_PATH})
link_directories(${MPI_Fortran_LIBRARIES})

# Libs to be linked with the Fortran codes
set(fortran_link_libs superlu_dist_fortran ${MPI_Fortran_LIBRARIES} ${BLAS_LIB} ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
if(BUILD_STATIC_LIBS)
  set(fortran_link_libs superlu_dist_fortran-static ${MPI_Fortran_LIBRARIES} ${BLAS_LIB} ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
endif()
set(all_link_libs ${fortran_link_libs} superlu_dist)

#message("!!! in Fortran: MPI_Fortran_LINK_FLAGS='${MPI_Fortran_LINK_FLAGS}'")
#message("!!! in Fortran: all_link_libs='${all_link_libs}'")
#message("!!! in Fortran: cxx_implicit='${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}'")
if (NOT MSVC)
  list(APPEND all_link_libs m)
endif ()

if(enable_examples)

if(enable_double)
## if(FALSE)
  set(F_DEXM f_pddrive.F90)
  add_executable(f_pddrive ${F_DEXM})
  target_link_libraries(f_pddrive ${all_link_libs})
# set_target_properties(f_pddrive PROPERTIES LINKER_LANGUAGE Fortran CUDA_RESOLVE_DEVICE_SYMBOLS ON)
  set_target_properties(f_pddrive PROPERTIES LINKER_LANGUAGE Fortran)
## CXX linker does not work with Intel compiler
# set_target_properties(f_pddrive PROPERTIES LINKER_LANGUAGE CXX LINK_FLAGS "${MPI_Fortran_LINK_FLAGS}")
  
  set(F_DEXM3D f_pddrive3d.F90)
  add_executable(f_pddrive3d ${F_DEXM3D})
  target_link_libraries(f_pddrive3d ${all_link_libs})
  set_target_properties(f_pddrive3d PROPERTIES LINKER_LANGUAGE Fortran)

  set(F_5x5 f_5x5.F90 sp_ienv.c)
  add_executable(f_5x5 ${F_5x5})
  target_link_libraries(f_5x5 ${all_link_libs})
  set_target_properties(f_5x5 PROPERTIES LINKER_LANGUAGE Fortran)

endif() ## enable_double

##if(FALSE)
if(enable_complex16)
  set(F_ZEXM f_pzdrive.F90)
  add_executable(f_pzdrive ${F_ZEXM})
  target_link_libraries(f_pzdrive ${all_link_libs})
  set_target_properties(f_pzdrive PROPERTIES LINKER_LANGUAGE Fortran)
#  set_target_properties(f_pzdrive PROPERTIES LINKER_LANGUAGE CXX LINK_FLAGS "${MPI_Fortran_LINK_FLAGS}")

  set(F_ZEXM3D f_pzdrive3d.F90)
  add_executable(f_pzdrive3d ${F_ZEXM3D})
  target_link_libraries(f_pzdrive3d ${all_link_libs})
  set_target_properties(f_pzdrive3d PROPERTIES LINKER_LANGUAGE Fortran)
#  set_target_properties(f_pzdrive3d PROPERTIES LINKER_LANGUAGE CXX LINK_FLAGS "${MPI_Fortran_LINK_FLAGS}")
endif() ## enable_complex16

endif ()  ## enable_example

# Format superlu_dist_config.fh from superlu_dist_config.h in C
add_custom_command(
  OUTPUT superlu_dist_config.fh
  COMMAND sed;'/^\\//;d';<;superlu_dist_config.h;>;superlu_dist_config.fh
  COMMAND cp;superlu_dist_config.fh;${SuperLU_DIST_SOURCE_DIR}/FORTRAN/.
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/FORTRAN
)
add_custom_target(config_f DEPENDS superlu_dist_config.fh)

=== PYTHON/CMakeLists.txt ===
# include the paths for header files
include_directories(${SuperLU_DIST_SOURCE_DIR}/SRC)
include_directories(${SuperLU_DIST_BINARY_DIR}/PYTHON)

set(sources
    pdbridge.h
    pdbridge.c
    )

# if(enable_complex16)
#   list(APPEND sources pzbridge.h pzbridge.c)
# endif()  

add_library(superlu_dist_python ${sources})
get_target_property(superlu_dist_version superlu_dist VERSION)
get_target_property(superlu_dist_soversion superlu_dist SOVERSION)
set_target_properties(superlu_dist_python PROPERTIES VERSION ${superlu_dist_version})
set_target_properties(superlu_dist_python PROPERTIES SOVERSION ${superlu_dist_soversion})
target_link_libraries(superlu_dist_python superlu_dist)
# add_dependencies(superlu_dist_python config_f)

set(PY_SCRIPT_SOURCE ${CMAKE_SOURCE_DIR}/PYTHON/pddrive.py)
set(PY_SCRIPT_DEST ${CMAKE_BINARY_DIR}/PYTHON/pddrive.py)
# Create a custom command to copy the Python script
add_custom_command(
    OUTPUT ${PY_SCRIPT_DEST}
    COMMAND ${CMAKE_COMMAND} -E copy ${PY_SCRIPT_SOURCE} ${PY_SCRIPT_DEST}
    DEPENDS ${PY_SCRIPT_SOURCE}
    COMMENT "Copying pddrive.py to ${CMAKE_BINARY_DIR}/PYTHON"
)

set(PY_SCRIPT_SOURCE ${CMAKE_SOURCE_DIR}/PYTHON/pdbridge.py)
set(PY_SCRIPT_DEST ${CMAKE_BINARY_DIR}/PYTHON/pdbridge.py)
# Create a custom command to copy the Python script
add_custom_command(
    OUTPUT ${PY_SCRIPT_DEST}
    COMMAND ${CMAKE_COMMAND} -E copy ${PY_SCRIPT_SOURCE} ${PY_SCRIPT_DEST}
    DEPENDS ${PY_SCRIPT_SOURCE}
    COMMENT "Copying pdbridge.py to ${CMAKE_BINARY_DIR}/PYTHON"
)

# Create a custom target named 'python' that depends on the output file
add_custom_target(python
    DEPENDS ${PY_SCRIPT_DEST}
)

add_dependencies(python superlu_dist_python)

install(TARGETS superlu_dist_python DESTINATION "${INSTALL_LIB_DIR}")
install(TARGETS superlu_dist_python DESTINATION "${INSTALL_LIB_DIR}/PYTHON")
install(FILES pddrive.py DESTINATION "${INSTALL_LIB_DIR}/PYTHON")
install(FILES pdbridge.py DESTINATION "${INSTALL_LIB_DIR}/PYTHON")
install(FILES pddrive_worker.py DESTINATION "${INSTALL_LIB_DIR}/PYTHON")
install(FILES pddrive_master.py DESTINATION "${INSTALL_LIB_DIR}/PYTHON")
install(FILES GP_demo.py DESTINATION "${INSTALL_LIB_DIR}/PYTHON")

=== SRC/CMakeLists.txt ===
set(headers
    include/superlu_FCnames.h
    include/dcomplex.h
    include/machines.h
    include/psymbfact.h
    include/superlu_defs.h
    include/superlu_enum_consts.h
    include/supermatrix.h
    include/util_dist.h
    include/gpu_api_utils.h
    include/gpu_wrapper.h
    include/superlu_upacked.h
    include/superlu_dist_config.h
    include/superlu_FortranCInterface.h
    include/oneside.h
    # CplusplusFactor/lupanels.hpp
    CplusplusFactor/commWrapper.hpp
    CplusplusFactor/lupanels_GPU.cuh
    CplusplusFactor/batch_block_copy.h
    CplusplusFactor/anc25d-GPU_impl.hpp
    CplusplusFactor/anc25d.hpp
    CplusplusFactor/anc25d_impl.hpp
    CplusplusFactor/lupanelsComm3dGPU_impl.hpp
    CplusplusFactor/lupanels_GPU_impl.hpp
    CplusplusFactor/lupanels_comm3d_impl.hpp
    CplusplusFactor/cublas_cusolver_wrappers.hpp
    CplusplusFactor/lupanels_impl.hpp
    CplusplusFactor/dAncestorFactor_impl.hpp
#    CplusplusFactor/pdgstrf3d_upacked_impl.hpp
    CplusplusFactor/dsparseTreeFactorGPU_impl.hpp
    CplusplusFactor/sparseTreeFactor_impl.hpp
#    CplusplusFactor/dsparseTreeFactor_upacked_impl.hpp
    CplusplusFactor/superlu_blas.hpp
    CplusplusFactor/l_panels_impl.hpp
    CplusplusFactor/u_panels_impl.hpp
    CplusplusFactor/luAuxStructTemplated.hpp
    # CplusplusFactor/xlupanels.hpp
    CplusplusFactor/lu_common.hpp
    CplusplusFactor/xlupanels_GPU.cuh
    CplusplusFactor/schurCompUpdate_impl.cuh
    CplusplusFactor/batch_factorize.h 
    CplusplusFactor/batch_factorize_marshall.h 
)
#    ${CMAKE_CURRENT_BINARY_DIR}/superlu_dist_config.h
#    ${PROJECT_SOURCE_DIR}/SRC/superlu_FortranCInterface.h
#    colamd.h
if (MSVC)
  list(APPEND headers wingetopt.h)
endif ()

# first: precision-independent files
set(sources
  prec-independent/sp_ienv.c
  prec-independent/etree.c 
  prec-independent/sp_colorder.c
  prec-independent/get_perm_c.c
  prec-independent/mmd.c
  prec-independent/comm.c
  prec-independent/memory.c
  prec-independent/util.c
  prec-independent/gpu_api_utils.c
  prec-independent/superlu_grid.c
  prec-independent/pxerr_dist.c
  prec-independent/superlu_timer.c
  prec-independent/symbfact.c
  prec-independent/ilu_level_symbfact.c
  prec-independent/psymbfact.c
  prec-independent/psymbfact_util.c
  prec-independent/get_perm_c_parmetis.c
  prec-independent/mc64ad_dist.c
  prec-independent/xerr_dist.c
  prec-independent/smach_dist.c
  prec-independent/dmach_dist.c
  prec-independent/superlu_dist_version.c
  prec-independent/comm_tree.c
  prec-independent/superlu_grid3d.c    ## 3D code
  prec-independent/supernodal_etree.c
  prec-independent/supernodalForest.c
  prec-independent/trfAux.c 
  prec-independent/communication_aux.c
  prec-independent/treeFactorization.c
  prec-independent/sec_structs.c  
  prec-independent/get_perm_c_batch.c
)

# Add all the BLAS routines: CplusplusFactor/supelu_blas.hpp needs all
list(APPEND sources
  double/dsuperlu_blas.c
  single/ssuperlu_blas.c
  complex16/zsuperlu_blas.c
)

# if (HAVE_CUDA)
#   list(APPEND sources cuda/superlu_gpu_utils.cu)
# endif()

# if (HAVE_HIP)
#   list(APPEND sources hip/superlu_gpu_utils.hip.cpp)
# endif()

if (MSVC)
  list(APPEND sources pred-independent/wingetopt.c)
endif ()

set_source_files_properties(superlu_timer.c PROPERTIES COMPILE_FLAGS -O0)

if(enable_double)
  list(APPEND headers
  include/superlu_ddefs.h include/dlustruct_gpu.h)

  list(APPEND sources
    double/dlangs_dist.c
    double/dgsequ_dist.c
    double/dlaqgs_dist.c
    double/dutil_dist.c
    double/dmemory_dist.c
    double/dmyblas2_dist.c
    double/dsp_blas2_dist.c
    double/dsp_blas3_dist.c
    double/pdgssvx.c
    double/pdgssvx_ABglobal.c
    double/dreadhb.c
    double/dreadrb.c
    double/dreadtriple.c
    double/dreadtriple_noheader.c
    double/dbinary_io.c	
    double/dreadMM.c
    double/pdgsequ.c
    double/pdlaqgs.c
    double/dldperm_dist.c
    double/pdlangs.c
    double/pdutil.c
    double/pdsymbfact_distdata.c
    double/ddistribute.c
    double/pddistribute.c
    double/pddistribute3d.c
    double/d3DPartition.c
    double/distCheckArray.c
    double/pddistribute-aux3d.c
    double/pdgstrf.c
    double/dstatic_schedule.c
    double/pdgstrf2.c
    double/pdgstrs.c
    double/pdgstrs3d.c
    double/pdgstrs1.c
    double/pdgstrs_lsum.c
    double/pdgstrs_Bglobal.c
    double/pdgsrfs.c
    double/pdgsmv.c
    double/pdgsrfs_ABXglobal.c
    double/pdgsmv_AXglobal.c
    double/pdGetDiagU.c
    double/pdgssvx3d.c     ## 3D code
    double/dssvx3dAux.c    
    double/dnrformat_loc3d.c 
    double/pdgstrf3d.c 
    double/dtreeFactorization.c
    double/dtreeFactorizationGPU.c
    double/dgather.c
    double/dscatter3d.c
    double/pd3dcomm.c
    double/dtrfAux.c	
    double/dcommunication_aux.c 
    double/dtrfCommWrapper.c
    double/dsuperlu_blas.c
    double/pdgssvx3d_csc_batch.c # batch in CSC format
    double/dequil_batch.c # batch in CSC format
    double/dpivot_batch.c
  )
  
if (TPL_ENABLE_CUDALIB)
  list(APPEND sources
       cuda/pdgstrs_lsum_cuda.cu cuda/superlu_gpu_utils.cu cuda/dsuperlu_gpu.cu
##       CplusplusFactor/schurCompUpdate.cu 
#       CplusplusFactor/pdgstrf3d_upacked.cpp
#       CplusplusFactor/dsparseTreeFactor_upacked.cpp
##      CplusplusFactor/dsparseTreeFactorGPU.cpp 
##       CplusplusFactor/lupanels.cpp
      #  CplusplusFactor/lupanels_comm3d.cpp
      #  CplusplusFactor/lupanelsComm3dGPU.cpp
       CplusplusFactor/commWrapper.cpp 
##       CplusplusFactor/l_panels.cpp
##       CplusplusFactor/u_panels.cpp
      #  CplusplusFactor/lupanels_GPU.cpp
##       CplusplusFactor/anc25d.cpp 
##       CplusplusFactor/anc25d-GPU.cpp 
##       CplusplusFactor/LUgpuCHandle_interface.cpp
       CplusplusFactor/LUgpuCHandle_interface_impl.cu  
       CplusplusFactor/batch_factorize.cu 
       CplusplusFactor/batch_block_copy.cu
  )
endif()

if (HAVE_COMBBLAS)
  list(APPEND sources double/d_c2cpp_GetHWPM.cpp double/dHWPM_CombBLAS.hpp)
endif()

endif() ########## enable double

if(enable_single)
  list(APPEND headers
       include/superlu_sdefs.h include/slustruct_gpu.h)

  list(APPEND sources
    single/slangs_dist.c
    single/sgsequ_dist.c
    single/slaqgs_dist.c
    single/sutil_dist.c
    single/smemory_dist.c
    single/smyblas2_dist.c
    single/ssp_blas2_dist.c
    single/ssp_blas3_dist.c
    single/psgssvx.c
    single/psgssvx_d2.c
    single/psgssvx_ABglobal.c
    single/sreadhb.c
    single/sreadrb.c
    single/sreadtriple.c
    single/sreadtriple_noheader.c
    single/sbinary_io.c	
    single/sreadMM.c
    single/psgsequ.c
    single/pslaqgs.c
    single/sldperm_dist.c
    single/pslangs.c
    single/psutil.c
    single/pssymbfact_distdata.c
    single/sdistribute.c
    single/psdistribute.c
    single/psdistribute3d.c
    single/s3DPartition.c
    single/psdistribute-aux3d.c
    single/psgstrf.c
    single/sstatic_schedule.c
    single/psgstrf2.c
    single/psgstrs.c
    single/psgstrs3d.c
    single/psgstrs1.c
    single/psgstrs_lsum.c
    single/psgstrs_Bglobal.c
    single/psgsrfs.c
    single/psgsrfs_d2.c
    single/psgsmv.c
    single/psgsrfs_ABXglobal.c
    single/psgsmv_AXglobal.c
    single/psGetDiagU.c
    single/psgssvx3d.c     ## 3D code
    single/sssvx3dAux.c  
    single/snrformat_loc3d.c 
    single/psgstrf3d.c 
    single/streeFactorization.c
    single/streeFactorizationGPU.c
    single/sgather.c
    single/sscatter3d.c
    single/ps3dcomm.c
    single/strfAux.c	
    single/scommunication_aux.c 
    single/strfCommWrapper.c
    single/ssuperlu_blas.c
    single/psgssvx_d2.c     # with double-precision IR
    single/psgsrfs_d2.c
    single/psgsmv_d2.c
    single/psgsequb.c
    single/psgssvx3d_csc_batch.c # batch in CSC format
    single/sequil_batch.c # batch in CSC format
    single/spivot_batch.c
  )
if (TPL_ENABLE_CUDALIB)
    list(APPEND sources cuda/psgstrs_lsum_cuda.cu cuda/ssuperlu_gpu.cu)
endif()
if (HAVE_COMBBLAS)
       list(APPEND sources single/s_c2cpp_GetHWPM.cpp double/dHWPM_CombBLAS.hpp)
endif()

endif() ########## enable single


if(enable_complex16)
  list(APPEND headers
       include/superlu_zdefs.h include/zlustruct_gpu.h)

      list(APPEND sources
      complex16/dcomplex_dist.c
      complex16/zlangs_dist.c
      complex16/zgsequ_dist.c
      complex16/zlaqgs_dist.c
      complex16/zutil_dist.c
      complex16/zmemory_dist.c
      complex16/zmyblas2_dist.c
      complex16/zsp_blas2_dist.c
      complex16/zsp_blas3_dist.c
      complex16/pzgssvx.c
      complex16/pzgssvx_ABglobal.c
      complex16/zreadhb.c
      complex16/zreadrb.c
      complex16/zreadtriple.c
      complex16/zreadtriple_noheader.c
      complex16/zbinary_io.c	
      complex16/zreadMM.c
      complex16/pzgsequ.c
      complex16/pzlaqgs.c
      complex16/zldperm_dist.c
      complex16/pzlangs.c
      complex16/pzutil.c
      complex16/pzsymbfact_distdata.c
      complex16/zdistribute.c
      complex16/pzdistribute.c
      complex16/pzdistribute3d.c
      complex16/z3DPartition.c
      complex16/pzdistribute-aux3d.c
      complex16/pzgstrf.c
      complex16/zstatic_schedule.c
      complex16/pzgstrf2.c
      complex16/pzgstrs.c
      complex16/pzgstrs3d.c
      complex16/pzgstrs1.c
      complex16/pzgstrs_lsum.c
      complex16/pzgstrs_Bglobal.c
      complex16/pzgsrfs.c
      complex16/pzgsmv.c
      complex16/pzgsrfs_ABXglobal.c
      complex16/pzgsmv_AXglobal.c
      complex16/pzGetDiagU.c
      complex16/pzgssvx3d.c     ## 3D code
      complex16/zssvx3dAux.c    
      complex16/znrformat_loc3d.c 
      complex16/pzgstrf3d.c 
      complex16/ztreeFactorization.c
      complex16/ztreeFactorizationGPU.c
      complex16/zgather.c
      complex16/zscatter3d.c
      complex16/pz3dcomm.c
      complex16/ztrfAux.c	
      complex16/zcommunication_aux.c 
      complex16/ztrfCommWrapper.c
      complex16/zsuperlu_blas.c
      complex16/pzgssvx3d_csc_batch.c # batch in CSC format
      complex16/zequil_batch.c # batch in CSC format
      complex16/zpivot_batch.c
     )
if (TPL_ENABLE_CUDALIB)
    list(APPEND sources cuda/pzgstrs_lsum_cuda.cu cuda/zsuperlu_gpu.cu)
endif()
if (HAVE_COMBBLAS)
    list(APPEND sources
         complex16/z_c2cpp_GetHWPM.cpp complex16/zHWPM_CombBLAS.hpp)
endif()
endif() ######### enable compex16

if (TPL_ENABLE_HIPLIB)
  file(GLOB MyFiles hip/*.hip.cpp)
  set_source_files_properties(
    ${MyFiles}
    PROPERTIES HIP_SOURCE_PROPERTY_FORMAT 1)

  set(hipsources
    hip/pdgstrs_lsum_cuda.hip.cpp
    hip/dsuperlu_gpu.hip.cpp
    hip/superlu_gpu_utils.hip.cpp
  )
  if(enable_single)
  list(APPEND hipsources hip/psgstrs_lsum_cuda.hip.cpp hip/ssuperlu_gpu.hip.cpp)
  endif()
  if(enable_complex16)
  list(APPEND hipsources hip/pzgstrs_lsum_cuda.hip.cpp hip/zsuperlu_gpu.hip.cpp)
  endif()
  hip_add_library(superlu_dist ${hipsources})
  if (BUILD_SHARED_LIBS AND BUILD_STATIC_LIBS)
    hip_add_library(superlu_dist-static STATIC  ${hipsources})
  endif()

else()
  add_library(superlu_dist "")
  if (BUILD_SHARED_LIBS AND BUILD_STATIC_LIBS)
    add_library(superlu_dist-static STATIC "")
  endif()
endif()


target_sources(superlu_dist PRIVATE ${sources} ${HEADERS})
set(targets superlu_dist)
target_compile_features(superlu_dist PUBLIC c_std_99)

if (BUILD_SHARED_LIBS AND BUILD_STATIC_LIBS)
  # build both shared and static libs
  target_sources(superlu_dist-static PRIVATE ${sources} ${HEADERS})
  target_compile_features(superlu_dist-static PUBLIC c_std_99)
  list(APPEND targets superlu_dist-static)
endif()

if (TPL_ENABLE_NVSHMEM)
set(superlu_dist_libs ${MPI_C_LIBRARIES} ${MPI_CXX_LIBRARIES} ${BLAS_LIB} ${LAPACK_LIB}
    ${PARMETIS_LIB} ${COLAMD_LIB} ${COMBBLAS_LIB} ${MAGMA_LIB} ${CUDA_LIB} ${HIP_LIB} ${NVSHMEM_LIB}) 
else()
set(superlu_dist_libs ${MPI_C_LIBRARIES} ${MPI_CXX_LIBRARIES} ${BLAS_LIB} ${LAPACK_LIB}
    ${PARMETIS_LIB} ${COLAMD_LIB} ${COMBBLAS_LIB} ${MAGMA_LIB} ${CUDA_LIB} ${HIP_LIB})
endif()

if (NOT MSVC)
  list(APPEND superlu_dist_libs m)
endif ()

foreach(target ${targets})
    target_link_libraries(${target} ${superlu_dist_libs})
    if (HAVE_COMBBLAS)

=== TEST/CMakeLists.txt ===
include_directories(${SuperLU_DIST_SOURCE_DIR}/SRC)

# Libs linked to all of the tests
set(all_link_libs superlu_dist ${BLAS_LIB})
if (NOT MSVC)
  list(APPEND all_link_libs m)
endif ()

set(MATRICES ../EXAMPLE/g20.rua)  # sample sparse matrix from a file
set(NPROWS 1 2 5)	  # process rows
set(NPCOLS 1 2 3) 	  # process columns
set(NVAL 9 19)	  	  # generated matrix dimensions
set(NRHS 1 3)		  # number of RHS
# set(FILLRATIO 2 10)	  # estimated fill ratio
set(FILLRATIO 2)	  # estimated fill ratio
# following are blocking parameters, see sp_ienv.c
set(RELAX 8)	   	  # relaxed supernode size: 4 8
set(SUPERSIZE 20)   	  # maximum supernode size: 10 20
set(MINGEMM 10000)	  # minimum GEMM size for GPU offload

function(cat IN_FILE OUT_FILE)
  file(READ ${IN_FILE} CONTENTS)
  file(APPEND ${OUT_FILE} "${CONTENTS}")
endfunction()

set(MPIEXEC_PREFLAGS "-oversubscribe")

# Function to perform test
# call API:  add_superlu_dist_tests(pddrive big.rua)
function(add_superlu_dist_tests target input)
   set(TEST_INPUT "${SuperLU_DIST_SOURCE_DIR}/EXAMPLE/${input}")
   set(TEST_OUTPUT "${SuperLU_DIST_BINARY_DIR}/TEST/${target}.out")

  # Prepare a temporary file to "cat" to:
  # file(WRITE ${TEST_OUTPUT} "")

##  get_target_property(TEST_LOC ${target} LOCATION)
   set(TEST_LOC ${CMAKE_CURRENT_BINARY_DIR})

   foreach (r ${NPROWS})
      foreach (c ${NPCOLS})
        MATH( EXPR np "${r}*${c}" )
        foreach (s ${NRHS})
	  foreach (b ${FILLRATIO})
	    foreach (x ${RELAX})
	      foreach (m ${SUPERSIZE})
                set(testName "${target}_${r}x${c}_${s}_${b}_${x}_${m}")
	  	set(SINGLE_OUTPUT ${SuperLU_DIST_BINARY_DIR}/TEST/${testName}.out)
          add_test( NAME ${testName}_SP
	    	    COMMAND ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} ${np}
            	    ${MPIEXEC_PREFLAGS} ${TEST_LOC}/${target} ${MPIEXEC_POSTFLAGS}
		    -r ${r} -c ${c} -s ${s} -b ${b} -x ${x} -m ${m} -f ${TEST_INPUT}
		  )
#          add_test( ${testName}_SP "${CMAKE_COMMAND}"
#	    -DTEST=${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${np}
#            ${MPIEXEC_PREFLAGS} ${target} ${MPIEXEC_POSTFLAGS} -r ${r} -c ${c} -s ${s} -b ${b} -x ${x} -m ${m} -f ${TEST_INPUT}
#	    -DOUTPUT=${SINGLE_OUTPUT}
#	    -DALL_OUTPUT=${TEST_OUTPUT}
#	    -DHEADING=Sparse\ matrix\ ${TEST_INPUT}\ --\ r=${r},\ c=${c},\ s=${s},\ x=${x},\ m=${m}
#	    -P "${SuperLU_DIST_SOURCE_DIR}/TEST/runtest.cmake"
#		  )
	      endforeach()
	    endforeach()
	  endforeach()
	endforeach()
      endforeach()
   endforeach()

# MPI variables:
# ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} PROCS
#  	${MPIEXEC_PREFLAGS} EXECUTABLE ${MPIEXEC_POSTFLAGS} ARGS)

endfunction(add_superlu_dist_tests)

if(enable_double)
  set(DTEST pdtest.c dcreate_matrix.c pdcompute_resid.c)
  add_executable(pdtest ${DTEST})
  target_link_libraries(pdtest ${all_link_libs})
  target_compile_features(pdtest PUBLIC c_std_99)
  add_superlu_dist_tests(pdtest g20.rua)
endif()

#if(enable_complex16)
#  set(ZTEST pztest.c zcreate_matrix.c pzcompute_resid.c)
#endif()

=== PATCH/parmetis/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ParMETIS)

set(GKLIB_PATH METIS/GKlib CACHE PATH "path to GKlib")
set(METIS_PATH METIS CACHE PATH "path to METIS")

# Symlink ./metis to wherever metis is. This allows files to be
# included from metis/libmetis/.
execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${METIS_PATH} metis)

# Search for MPI.
# GK commented this out as it seems to be creating problems
# include(FindMPI)
# if(NOT MPI_FOUND)
#   message(FATAL_ERROR "mpi is not found")
# endif()
# set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${MPI_COMPILE_FLAGS}")

# Prepare libraries.
if(SHARED)
  set(ParMETIS_LIBRARY_TYPE SHARED)
  set(METIS_LIBRARY_TYPE SHARED)
else()
  set(ParMETIS_LIBRARY_TYPE STATIC)
  set(METIS_LIBRARY_TYPE STATIC)
endif()

include(${GKLIB_PATH}/GKlibSystem.cmake)

# List of paths that the compiler will search for header files.
# i.e., the -I equivalent
include_directories(include)
include_directories(${MPI_INCLUDE_PATH})
include_directories(${GKLIB_PATH})
include_directories(${METIS_PATH}/include)

# List of directories that cmake will look for CMakeLists.txt
add_subdirectory(${METIS_PATH}/libmetis ${CMAKE_BINARY_DIR}/libmetis)
add_subdirectory(include)
add_subdirectory(libparmetis)
add_subdirectory(programs)

# This is for testing during development and is not being distributed
#add_subdirectory(test)

=== debian/control ===
Source: superlu-dist
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-fortran-mod,
               cmake,
               mpi-default-dev,
               mpi-default-bin,
               gfortran,
               libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
               libcombblas-dev,
               libscotchparmetis-dev,
               libmetis-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/superlu-dist
Vcs-Git: https://salsa.debian.org/science-team/superlu-dist.git
Homepage: https://github.com/xiaoyeli/superlu_dist
Rules-Requires-Root: no

Package: libsuperlu-dist-dev
Architecture: any
Multi-Arch: same
Depends: libsuperlu-dist9 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${fortran:Depends}
Suggests: libsuperlu-dist-examples (= ${binary:Version})
Description: Highly distributed solution of sparse linear equations
 SuperLU is a general purpose library for the direct solution of large,
 sparse, nonsymmetric systems of linear equations. The library is
 written in C and is callable from either C or Fortran program. It uses
 MPI, OpenMP and CUDA to support various forms of parallelism. It
 supports both real and complex datatypes, both single and double
 precision, and 64-bit integer indexing. The library routines performs
 an LU decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.
 .
 SuperLU_DIST implements the algorithms for distributed memory,
 targetting highly parallel distributed memory hybrid systems. The
 numerical factorization routines are already implemented for hybrid
 systems with multiple GPUs. Further work will be needed to implement
 the other phases of the algorithms on the hybrid systems and to
 enhance strong scaling to extreme scale.
 .
 The main library is libsuperlu_dist.so but a fortran wrapper library
 is also provided as libsuperlu_dist_fortran.so, and a python wrapper
 is provided as libsuperlu_dist_python.so (see PYTHON examples in the
 libsuperlu-dist-examples package).
 .
 This package provides development files for building client
 applications against superlu-dist.

Package: libsuperlu-dist9
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Highly distributed solution of sparse linear equations
 SuperLU is a general purpose library for the direct solution of large,
 sparse, nonsymmetric systems of linear equations. The library is
 written in C and is callable from either C or Fortran program. It uses
 MPI, OpenMP and CUDA to support various forms of parallelism. It
 supports both real and complex datatypes, both single and double
 precision, and 64-bit integer indexing. The library routines performs
 an LU decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.
 .
 SuperLU_DIST implements the algorithms for distributed memory,
 targetting highly parallel distributed memory hybrid systems. The
 numerical factorization routines are already implemented for hybrid
 systems with multiple GPUs. Further work will be needed to implement
 the other phases of the algorithms on the hybrid systems and to
 enhance strong scaling to extreme scale.
 .
 The main library is libsuperlu_dist.so but a fortran wrapper library
 is also provided as libsuperlu_dist_fortran.so
 .
 This package provides the superlu-dist and superlu_dist_fortran
 shared libraries.

Package: libsuperlu-dist-examples
Architecture: any
Multi-Arch: same
Depends: libsuperlu-dist9 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${fortran:Depends}
Description: Highly distributed solution of sparse linear equations
 SuperLU is a general purpose library for the direct solution of large,
 sparse, nonsymmetric systems of linear equations. The library is
 written in C and is callable from either C or Fortran program. It uses
 MPI, OpenMP and CUDA to support various forms of parallelism. It
 supports both real and complex datatypes, both single and double
 precision, and 64-bit integer indexing. The library routines performs
 an LU decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.
 .
 SuperLU_DIST implements the algorithms for distributed memory,
 targetting highly parallel distributed memory hybrid systems. The
 numerical factorization routines are already implemented for hybrid
 systems with multiple GPUs. Further work will be needed to implement
 the other phases of the algorithms on the hybrid systems and to
 enhance strong scaling to extreme scale.
 .
 This package provides example files for testing superlu-dist.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/mpi-default-dev/debian_defaults

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# ignore test errors for some arches:
#   x32 times out in some tests
#   ia64 times out or fails some tests
ARCH_IGNORE_TEST_ERROR = ia64 x32

empty :=
space := $(empty)$(empty)

# ignore test errors, or not
IGNORE_TEST_ERROR=/bin/false
ifneq (,$(findstring $(ARCH_DEFAULT_MPI_IMPL),openmpi))
  MPIEXEC_FLAGS=--allow-run-as-root
endif

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_IGNORE_TEST_ERROR)$(space)))
  IGNORE_TEST_ERROR=/bin/true
endif

# Allow test programs that use OpenMPI to run
export PRTE_MCA_plm_ssh_agent=/bin/false
export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe

export BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@ --buildsystem=cmake --with fortran_mod

override_dh_clean:
	dh_clean
	rm -f make.inc FORTRAN/superlu_dist_config.fh SRC/superlu_dist_config.h

# NOTE: the superlu-dist cmake scripts generate a configuration error:
#   CMake Error in SRC/CMakeLists.txt:
#    Found relative path while evaluating include directories of "superlu_dist":
#      "OFF"
# with error code 1, which causes the build to halt.
# But the configuration seems fine (GNUInstallDirs are used to define standard install dirs).
# For now, work around the error by ignoring it (append "|| /bin/true")
override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON -DCMAKE_SKIP_RPATH=ON \
	    -DCMAKE_C_COMPILER=mpicc \
	    -DCMAKE_CXX_COMPILER=mpic++ \
	    -DXSDK_ENABLE_Fortran=ON \
	    -DCMAKE_FORTRAN_COMPILER=mpifort \
	    -DMPIEXEC_PREFLAGS=$(MPIEXEC_FLAGS) \
	    -DCMAKE_INSTALL_INCLUDEDIR=include/superlu-dist \
	    -Denable_complex16=ON \
	    -DTPL_ENABLE_INTERNAL_BLASLIB=OFF -DTPL_BLAS_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libblas.so \
	    -DTPL_ENABLE_LAPACKLIB=ON -DTPL_LAPACK_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/liblapack.so \
	    -DTPL_ENABLE_PARMETISLIB=ON \
	      -DTPL_PARMETIS_LIBRARIES="-lparmetis -lmetis" \
	      -DTPL_PARMETIS_INCLUDE_DIRS="/usr/include/parmetis" \
	    -DTPL_ENABLE_COMBBLASLIB=ON \
	      -DTPL_COMBBLAS_LIBRARIES="-lCombBLAS -lGraphGenlib -lUsortlib" \
	      -DTPL_COMBBLAS_INCLUDE_DIRS=/usr/include/CombBLAS/ \
	  || /bin/true


# set LD_LIBRARY_PATH to test against the libsuperlu_dist.so just built
override_dh_auto_test:
	export LD_LIBRARY_PATH=$(CURDIR)/$(BUILDDIR)/SRC:$${LD_LIBRARY_PATH}; \
	OMP_NUM_THREADS=1 LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test --max-parallel=1 || $(IGNORE_TEST_ERROR)

execute_after_dh_install:
	for testfile in $$( find debian/libsuperlu-dist-examples -name CTestTestfile.cmake ); do \
	    sed -e "s|$(CURDIR)|<<builddir>>/superlu-dist|g;" \
		-i $$testfile; \
	    sed -r "s|(.*)\".*/(EXAMPLE/.*ua)|\1\"/usr/lib/$(DEB_HOST_MULTIARCH)/superlu-dist/\2|" \
		-i $$testfile; \
	done
